#!/usr/bin/env python
from __future__ import with_statement
import wx.stc as stc

global prev  #this is for making sure the ctrl key was hit before this key f.e.
prev = 0
global commands
#format  ["emacs_keybinding", "commandbinding", ord(char), command, "deditor_keybinding"]
commands = [
["C-a", "beginning-of-line", (308,65), stc.STC_CMD_HOME, "ctrl+a"],
["C-b", "backward-char", (308,66), stc.STC_CMD_CHARLEFT, "ctrl+b"],
["C-e", "end-of-line", (308,69), stc.STC_CMD_LINEEND, "ctrl+e"],
["C-f", "forward-char", (308,70), stc.STC_CMD_CHARRIGHT, "ctrl+f"],
["C-n", "next-line", (308,78), stc.STC_CMD_LINEDOWN, "ctrl+n"],
["C-p", "previous-line", (308,80), stc.STC_CMD_LINEUP, "ctrl+p"],
["Alt-p", "down-one", (307,80), stc.STC_CMD_LINESCROLLUP, "alt+p"],
["Alt-n", "up-one", (307,78), stc.STC_CMD_LINESCROLLDOWN, "alt+n"],
["C-w", "kill-region", (308,87), stc.STC_CMD_CUT, "ctrl+w"],
["C-y", "yank", (308,87), stc.STC_CMD_PASTE, "ctrl+y"],
["C-k", "kill-line", (308,75), stc.STC_CMD_LINEDELETE, "ctrl+k"],
["C-v", "scroll-up", (308,86), stc.STC_CMD_PAGEDOWN, "ctrl+v"],
["C-_", "undo", (308,95), stc.STC_CMD_UNDO, "ctrl+_"],
]
#C-x, M-x not included as they aren't one single command

def init_dplug(dplug):
    dplug.add_to("sheetupdate","emacs")
    dplug.add_cmd("C-x", "emacs")
    dplug.add_cmd("M-x", "emacs")
    
    init_keys(dplug)

def trigger(trig, dplug, val = ""):
    if trig == "sheetupdate":
        return sh_upd(dplug, val)

def command(cmd, next, dplug):
    page = dplug.main_class.notebook.GetSelection()
    sheet = dplug.get_module("deditor").sheets[page]
    for command in commands:
        if cmd == "M-x" and next.strip().split(" ")[0] == command[1]:   sheet[1].CmdKeyExecute(command[3])
    if cmd == "C-x":
        next = next.strip().split(" ")
        if next[0] == "f":  dplug.main_class.open_file()
        elif next[0] == "s":    dplug.main_class.save_file()
        elif next[0] == "C-c":  dplug.main_class.quit()
        elif next[0] == "C-f": dplug.main_class.open_file()
        elif next[0] == "C-s": dplug.main_class.save_file()
        elif next[0] == "C-w": dplug.main_class.saveas()
    sheet[1].SetFocus()

def init_keys(dplug):
    _ = dplug.register_keybinding
    for i in commands:
        if dplug.is_keybinding(i[4]):
            dplug.remove_keybinding(i[4])
        _("emacs", i[1], i[4])

def sh_upd(dplug, val):
    global prev
    _ = dplug.get_keybinding
    evt, sheet = val
    x = evt.GetKeyCode()
    found=False
    for command in commands:
        if command[2][0] == prev and x == command[2][1] and _("emacs", command[1]) == command[4]:
            sheet[1].CmdKeyExecute(command[3])
            found = True
    prev = x
    return not found